Skip to main content Skip to footer

Identifying and Clearing Applied FlexGrid Filters in JavaScript

Background

In a JavaScript application, you can identify the columns where filters are applied by reading the filterDefinition property of FlexGridFilter. Since filterDefinition is stored as a JSON string, parse it with JSON.parse.

Sorting information is available from the grid’s collectionView.sortDescriptions collection.

Steps to Complete

  1. Install and import the Wijmo grid packages.
  2. Create the grid host elements.
  3. Define the grid data and columns.
  4. Initialize the FlexGrid and FlexGridFilter.
  5. Read applied filters from filterDefinition.
  6. Read applied sorting from sortDescriptions.
  7. Clear a specific column’s filter and sort.
  8. Clear all filters and sorting.
  9. Add the Button Events.

Getting Started

Install and import the Wijmo grid packages

npm install @mescius/wijmo.grid @mescius/wijmo.grid.filter @mescius/wijmo.styles
import '@mescius/wijmo.styles/wijmo.css';

import * as wjcGrid from '@mescius/wijmo.grid';
import * as wjcGridFilter from '@mescius/wijmo.grid.filter';
  • wijmo.grid provides FlexGrid, and wijmo.grid.filter provides FlexGridFilter.

 

Create the grid host elements

<p id="filterStatus">Filters (0): None</p>
<p id="sortStatus">Sorts (0): None</p>

<div id="columnButtons"></div>

<button id="clearAllButton" type="button">
  Clear All Filters and Sorting
</button>

<div id="theGrid"></div>
  • The theGrid element is used as the host element for the Wijmo FlexGrid.

 

Define the grid data and columns

const columns = [
  { binding: 'id', header: 'Id' },
  { binding: 'country', header: 'Country' },
  { binding: 'date', header: 'Date' },
  { binding: 'amount', header: 'Amount' },
  { binding: 'active', header: 'Active' }
];

const data = getData(20);

function getData(count) {
  const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');

  return Array.from({ length: count }, (_, index) => ({
    id: index,
    country: countries[index % countries.length],
    date: new Date(2026, index % 12, (index % 28) + 1),
    amount: Math.round(Math.random() * 10000),
    active: index % 4 === 0
  }));
}
  • The binding values are used by both filterDefinition and sortDescriptions.

 

Initialize the FlexGrid and FlexGridFilter

const flex = new wjcGrid.FlexGrid('#theGrid', {
  autoGenerateColumns: false,
  columns,
  itemsSource: data,
  allowSorting: wjcGrid.AllowSorting.MultiColumn
});

const gridFilter = new wjcGridFilter.FlexGridFilter(flex);

gridFilter.filterApplied.addHandler(refreshGridState);
flex.sortedColumn.addHandler(refreshGridState);
  • FlexGridFilter adds Excel-style filtering to the grid. The event handlers update the displayed filter and sort information whenever the user changes the grid state.

 

Read applied filters from filterDefinition

function getFilterDefinition() {
  if (!gridFilter.filterDefinition) {
    return { filters: [] };
  }

  return JSON.parse(gridFilter.filterDefinition);
}

function getColumnHeader(binding) {
  const column = flex.getColumn(binding);
  return column ? column.header : binding;
}
  • Each item in filterDefinition.filters represents a column with an active filter.

 

Read applied sorting from sortDescriptions

function refreshGridState() {
  const filterDefinition = getFilterDefinition();

  const filteredColumns = (filterDefinition.filters || []).map(filter =>
    getColumnHeader(filter.binding)
  );

  const sortedColumns = [];
  const sorts = flex.collectionView.sortDescriptions;

  for (let i = 0; i < sorts.length; i++) {
    const sort = sorts[i];
    const direction = sort.ascending ? 'ascending' : 'descending';
    sortedColumns.push(`${getColumnHeader(sort.property)} (${direction})`);
  }

  document.querySelector('#filterStatus').textContent =
    `Filters (${filteredColumns.length}): ${filteredColumns.join(', ') || 'None'}`;

  document.querySelector('#sortStatus').textContent =
    `Sorts (${sortedColumns.length}): ${sortedColumns.join(', ') || 'None'}`;
}
  • This updates the number of applied filters and shows the filtered and sorted column names.

 

Clear a specific column’s filter and sort

function clearColumnFilterAndSort(binding) {
  const filterDefinition = getFilterDefinition();

  filterDefinition.filters = (filterDefinition.filters || []).filter(
    filter => filter.binding !== binding
  );

  gridFilter.filterDefinition = JSON.stringify(filterDefinition);

  const sorts = flex.collectionView.sortDescriptions;

  for (let i = sorts.length - 1; i >= 0; i--) {
    if (sorts[i].property === binding) {
      sorts.splice(i, 1);
    }
  }

  refreshGridState();
}
  • This clears only the selected column’s filter and sort.

 

Clear all filters and sorting

function clearAllFiltersAndSorts() {
  flex.collectionView.sortDescriptions.clear();
  gridFilter.clear();

  refreshGridState();
}
  • This resets the grid to an unfiltered and unsorted state.

 

Add the Button Events

const buttonHost = document.querySelector('#columnButtons');

columns.forEach(column => {
  const button = document.createElement('button');
  button.type = 'button';
  button.textContent = `Clear ${column.header}`;
  button.addEventListener('click', () => {
    clearColumnFilterAndSort(column.binding);
  });

  buttonHost.appendChild(button);
});

document
  .querySelector('#clearAllButton')
  .addEventListener('click', clearAllFiltersAndSorts);

refreshGridState();

 

With this setup, the JavaScript application can show the number of active filters, display the filtered and sorted column names, clear one column’s filter and sort, or clear all filters and sorting from the grid.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Identifying and Clearing Applied FlexGrid Filters in Vue

Background

In a Vue application, you can identify which columns currently have filters applied by reading the filterDefinition property of FlexGridFilter. Since filterDefinition is stored as a JSON string, parse it with JSON.parse.

Sorting information is available from the grid’s collectionView.sortDescriptions collection.

Steps to Complete

  1. Install and import the Wijmo Vue grid packages.
  2. Create the grid data and column definitions.
  3. Store references to the FlexGrid and FlexGridFilter.
  4. Read applied filters from filterDefinition.
  5. Read applied sorting from sortDescriptions.
  6. Clear a specific column’s filter and sort.
  7. Clear all filters and sorting.
  8. Add the Vue Template

Getting Started

Install and import the Wijmo Vue grid packages

npm install @mescius/wijmo.vue2.all

Import the required Vue components and Wijmo styles in App.vue:

<script setup>
import { ref } from 'vue';
import '@mescius/wijmo.styles/wijmo.css';

import { WjFlexGrid, WjFlexGridColumn } from '@mescius/wijmo.vue2.grid';
import { WjFlexGridFilter } from '@mescius/wijmo.vue2.grid.filter';
</script>
  • The WjFlexGrid component displays the data grid, while WjFlexGridFilter adds Excel-like filtering to the grid.

 

Create the grid data and column definitions

<script setup>
const columns = [
  { binding: 'id', header: 'Id' },
  { binding: 'country', header: 'Country' },
  { binding: 'date', header: 'Date' },
  { binding: 'amount', header: 'Amount' },
  { binding: 'active', header: 'Active' }
];

const data = ref(getData(20));

function getData(count) {
  const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');

  return Array.from({ length: count }, (_, index) => ({
    id: index,
    country: countries[index % countries.length],
    date: new Date(2026, index % 12, (index % 28) + 1),
    amount: Math.round(Math.random() * 10000),
    active: index % 4 === 0
  }));
}
</script>
  • The binding values are important because filters and sorts are both tracked by column binding.

 

Store references to the FlexGrid and FlexGridFilter

<script setup>
const flex = ref(null);
const gridFilter = ref(null);

function onGridInitialized(sender) {
  flex.value = sender;
  refreshGridState();
}

function onFilterInitialized(sender) {
  gridFilter.value = sender;
  refreshGridState();
}
</script>
  • The grid reference gives access to sorting, and the filter reference gives access to filterDefinition.

 

Read applied filters from filterDefinition

<script setup>
const filteredColumns = ref([]);

function getFilterDefinition() {
  if (!gridFilter.value?.filterDefinition) {
    return { filters: [] };
  }

  return JSON.parse(gridFilter.value.filterDefinition);
}

function getColumnHeader(binding) {
  return flex.value?.getColumn(binding)?.header ?? binding;
}
</script>
  • Each item in filterDefinition.filters represents one filtered column.

 

Read applied sorting from sortDescriptions

<script setup>
const sortedColumns = ref([]);

function refreshGridState() {
  if (!flex.value || !gridFilter.value) {
    return;
  }

  const filterDefinition = getFilterDefinition();

  filteredColumns.value = (filterDefinition.filters ?? []).map(filter =>
    getColumnHeader(filter.binding)
  );

  const sorts = flex.value.collectionView.sortDescriptions;
  sortedColumns.value = [];

  for (let i = 0; i < sorts.length; i++) {
    const sort = sorts[i];
    const direction = sort.ascending ? 'ascending' : 'descending';

    sortedColumns.value.push(
      `${getColumnHeader(sort.property)} (${direction})`
    );
  }
}
</script>
  • This method updates both the filtered column count and the sorted column list.

 

Clear a specific column’s filter and sort

<script setup>
function clearColumnFilterAndSort(binding) {
  if (!flex.value || !gridFilter.value) {
    return;
  }

  const filterDefinition = getFilterDefinition();

  filterDefinition.filters = (filterDefinition.filters ?? []).filter(
    filter => filter.binding !== binding
  );

  gridFilter.value.filterDefinition = JSON.stringify(filterDefinition);

  const sorts = flex.value.collectionView.sortDescriptions;

  for (let i = sorts.length - 1; i >= 0; i--) {
    if (sorts[i].property === binding) {
      sorts.splice(i, 1);
    }
  }

  refreshGridState();
}
</script>
  • This clears only the selected column’s filter and sort.

 

Clear all filters and sorting

<script setup>
function clearAllFiltersAndSorts() {
  if (!flex.value || !gridFilter.value) {
    return;
  }

  flex.value.collectionView.sortDescriptions.clear();
  gridFilter.value.clear();

  refreshGridState();
}
</script>
  • This resets the grid to an unfiltered and unsorted state.

 

Add the Vue Template

<template>
  <p>
    Filters ({{ filteredColumns.length }}):
    {{ filteredColumns.join(', ') || 'None' }}
  </p>

  <p>
    Sorts ({{ sortedColumns.length }}):
    {{ sortedColumns.join(', ') || 'None' }}
  </p>

  <button
    v-for="column in columns"
    :key="column.binding"
    type="button"
    @click="clearColumnFilterAndSort(column.binding)">
    Clear {{ column.header }}
  </button>

  <button type="button" @click="clearAllFiltersAndSorts">
    Clear All Filters and Sorting
  </button>

  <wj-flex-grid
    :items-source="data"
    allow-sorting="MultiColumn"
    :initialized="onGridInitialized"
    :sorted-column="refreshGridState">

    <wj-flex-grid-column
      v-for="column in columns"
      :key="column.binding"
      :binding="column.binding"
      :header="column.header" />

    <wj-flex-grid-filter
      :initialized="onFilterInitialized"
      :filter-applied="refreshGridState" />
  </wj-flex-grid>
</template>
  • The filterApplied event refreshes the filter information after filtering changes. The sortedColumn event refreshes the sort information after the user sorts a column.

 

With this setup, the Vue application can show the number of active filters, display the filtered and sorted column names, clear one column’s filter and sort, or clear all filters and sorting from the grid.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Identifying and Clearing Applied FlexGrid Filters in React

Background

In some React applications, you may need to display how many filters are currently applied to a Wijmo FlexGrid, show which columns are filtered, and allow users to clear filtering or sorting from a specific column.

You can get the active filter information from the filterDefinition property of FlexGridFilter. This property is stored as a JSON string, so it should be parsed with JSON.parse. Sorting information is available through the grid’s collectionView.sortDescriptions collection.

Steps to Complete

  1. Install and import the Wijmo React grid packages.
  2. Create the FlexGrid data and column definitions.
  3. Read active filters from filterDefinition.
  4. Track the filtered and sorted columns.
  5. Clear a specific column’s filter and sort.
  6. Clear all filters and sorting.
  7. Render the FlexGrid and status controls.

Getting Started

Install and import the Wijmo React grid packages

npm install @mescius/wijmo @mescius/wijmo.react.grid @mescius/wijmo.react.grid.filter @mescius/wijmo.styles
import React, { useCallback, useMemo, useRef, useState } from 'react';
import '@mescius/wijmo.styles/wijmo.css';

import { FlexGrid, FlexGridColumn } from '@mescius/wijmo.react.grid';
import { FlexGridFilter } from '@mescius/wijmo.react.grid.filter';
  • The React grid package provides the FlexGrid component, while the grid filter package provides FlexGridFilter.

 

Create the FlexGrid data and column definitions

const columns = [
  { binding: 'id', header: 'Id' },
  { binding: 'country', header: 'Country' },
  { binding: 'date', header: 'Date' },
  { binding: 'amount', header: 'Amount' },
  { binding: 'active', header: 'Active' }
];

function getData(count) {
  const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');

  return Array.from({ length: count }, (_, index) => ({
    id: index,
    country: countries[index % countries.length],
    date: new Date(2026, index % 12, (index % 28) + 1),
    amount: Math.round(Math.random() * 10000),
    active: index % 4 === 0
  }));
}
  • The binding values are important because both filterDefinition and sortDescriptions identify columns by binding.

 

Read active filters from filterDefinition

function asArray(collection) {
  const result = [];

  for (let i = 0; i < collection.length; i++) {
    result.push(collection[i]);
  }

  return result;
}

function getFilterDefinition(filter) {
  if (!filter?.filterDefinition) {
    return { defaultFilterType: filter?.defaultFilterType, filters: [] };
  }

  return JSON.parse(filter.filterDefinition);
}
  • filterDefinition contains the active column filters as a JSON string. The filters array contains one item for each filtered column.

 

Track the filtered and sorted columns

export default function App() {
  const data = useMemo(() => getData(20), []);
  const gridRef = useRef(null);
  const filterRef = useRef(null);

  const [gridState, setGridState] = useState({
    filters: [],
    sorts: []
  });

  const refreshGridState = useCallback(() => {
    const grid = gridRef.current?.control;
    const filter = filterRef.current;

    if (!grid || !filter) {
      return;
    }

    const filterDefinition = getFilterDefinition(filter);

    const filters = (filterDefinition.filters || []).map(item => {
      const column = grid.getColumn(item.binding);
      return column?.header || item.binding;
    });

    const sorts = asArray(grid.collectionView.sortDescriptions).map(desc => {
      const column = grid.getColumn(desc.property);
      const columnName = column?.header || desc.property;
      return `${columnName} (${desc.ascending ? 'ascending' : 'descending'})`;
    });

    setGridState({ filters, sorts });
  }, []);
  • The filter list comes from filterDefinition.filters. The sort list comes from collectionView.sortDescriptions.

 

Clear a specific column’s filter and sort

  const clearColumnFilterAndSort = useCallback((binding) => {
    const grid = gridRef.current?.control;
    const filter = filterRef.current;

    if (!grid || !filter) {
      return;
    }

    const filterDefinition = getFilterDefinition(filter);

    filterDefinition.filters = (filterDefinition.filters || []).filter(
      item => item.binding !== binding
    );

    filter.filterDefinition = JSON.stringify(filterDefinition);

    const sortDescriptions = grid.collectionView.sortDescriptions;

    for (let i = sortDescriptions.length - 1; i >= 0; i--) {
      if (sortDescriptions[i].property === binding) {
        sortDescriptions.splice(i, 1);
      }
    }

    refreshGridState();
  }, [refreshGridState]);
  • This removes the selected column from the filter definition and removes any sort description that uses the same binding.

 

Clear all filters and sorting

  const clearAllFiltersAndSorts = useCallback(() => {
    const grid = gridRef.current?.control;
    const filter = filterRef.current;

    if (!grid || !filter) {
      return;
    }

    grid.collectionView.sortDescriptions.clear();
    filter.clear();

    refreshGridState();
  }, [refreshGridState]);
  • The clear method removes all filters from FlexGridFilter, and sortDescriptions.clear() removes all sorting from the grid’s CollectionView.

 

Render the FlexGrid and status controls

  return (
    <div>
      <p>
        Filters ({gridState.filters.length}): {gridState.filters.join(', ') || 'None'}
      </p>
      <p>
        Sorts ({gridState.sorts.length}): {gridState.sorts.join(', ') || 'None'}
      </p>

      {columns.map(column => (
        <button
          key={column.binding}
          onClick={() => clearColumnFilterAndSort(column.binding)}
        >
          Clear {column.header}
        </button>
      ))}

      <button onClick={clearAllFiltersAndSorts}>
        Clear All Filters and Sorting
      </button>

      <FlexGrid
        ref={gridRef}
        itemsSource={data}
        allowSorting="MultiColumn"
        sortedColumn={refreshGridState}
      >
        {columns.map(column => (
          <FlexGridColumn
            key={column.binding}
            binding={column.binding}
            header={column.header}
          />
        ))}

        <FlexGridFilter
          initialized={filter => {
            filterRef.current = filter;
            refreshGridState();
          }}
          filterApplied={refreshGridState}
        />
      </FlexGrid>
    </div>
  );
}
  • The filterApplied event updates the displayed filter count after a filter is applied. The sortedColumn event updates the displayed sorting information after the user sorts a column.

 

With this setup, the React application can show the number of active filters, display the column names for active filters and sorts, clear a specific column’s filter and sort, or clear all filters and sorting from the grid.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Identifying and Clearing Applied FlexGrid Filters in Angular

Background

In some Angular applications, you may need to show how many filters are currently applied to a Wijmo FlexGrid, display the column names that are filtered, and allow users to clear filtering or sorting from a specific column.

You can get the active filter information from the filterDefinition property of FlexGridFilter. Since this value is stored as a JSON string, parse it with JSON.parse. Sorting information is available from the grid’s collectionView.sortDescriptions.

Steps to Complete

  1. Install and import the Wijmo Angular grid modules.
  2. Create the grid data and column definitions.
  3. Store references to the FlexGrid and FlexGridFilter.
  4. Read filtered columns from filterDefinition.
  5. Read sorted columns from sortDescriptions.
  6. Clear a specific column’s filter and sort, or clear all filters and sorting.
  7. Clear All Filters and Sorting.
  8. Add the Angular Markup.

Getting Started

Install and import the Wijmo Angular grid modules

npm install @mescius/wijmo.angular2.all
import { CommonModule } from '@angular/common';
import { Component } from '@angular/core';
import '@mescius/wijmo.styles/wijmo.css';

import * as wjcGrid from '@mescius/wijmo.grid';
import * as wjcGridFilter from '@mescius/wijmo.grid.filter';

import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { WjGridFilterModule } from '@mescius/wijmo.angular2.grid.filter';
  • These imports provide the Angular wj-flex-grid and wj-flex-grid-filter components.

 

Create the grid data and column definitions

columns = [
  { binding: 'id', header: 'Id' },
  { binding: 'country', header: 'Country' },
  { binding: 'date', header: 'Date' },
  { binding: 'amount', header: 'Amount' },
  { binding: 'active', header: 'Active' }
];

data = this.getData(20);

private getData(count: number): unknown[] {
  const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');

  return Array.from({ length: count }, (_, index) => ({
    id: index,
    country: countries[index % countries.length],
    date: new Date(2026, index % 12, (index % 28) + 1),
    amount: Math.round(Math.random() * 10000),
    active: index % 4 === 0
  }));
}
  • The binding values are important because both filters and sorts are tracked by column binding.

 

Store references to the FlexGrid and FlexGridFilter

private flex?: wjcGrid.FlexGrid;
private gridFilter?: wjcGridFilter.FlexGridFilter;

onGridInitialized(grid: wjcGrid.FlexGrid): void {
  this.flex = grid;
  this.refreshGridState();
}

onFilterInitialized(filter: wjcGridFilter.FlexGridFilter): void {
  this.gridFilter = filter;
  this.refreshGridState();
}
  • The grid reference gives access to sorting, while the filter reference gives access to filterDefinition.

 

Read filtered columns from filterDefinition

type FilterDefinition = {
  defaultFilterType?: number;
  filters?: Array<{ binding: string; [key: string]: unknown }>;
};

filteredColumns: string[] = [];

private getFilterDefinition(): FilterDefinition {
  if (!this.gridFilter?.filterDefinition) {
    return { filters: [] };
  }

  return JSON.parse(this.gridFilter.filterDefinition);
}
  • Each item in filters represents one filtered column.

 

Read sorted columns from sortDescriptions

sortedColumns: string[] = [];

refreshGridState(): void {
  if (!this.flex || !this.gridFilter) {
    return;
  }

  const filterDefinition = this.getFilterDefinition();

  this.filteredColumns = (filterDefinition.filters ?? []).map(filter =>
    this.getColumnHeader(filter.binding)
  );

  const sorts = this.flex.collectionView.sortDescriptions;
  this.sortedColumns = [];

  for (let i = 0; i < sorts.length; i++) {
    const sort = sorts[i];
    const direction = sort.ascending ? 'ascending' : 'descending';

    this.sortedColumns.push(
      `${this.getColumnHeader(sort.property)} (${direction})`
    );
  }
}

private getColumnHeader(binding: string): string {
  return this.flex?.getColumn(binding)?.header ?? binding;
}
  • This method updates both the filtered column list and sorted column list.

 

Clear a specific column’s filter and sort, or clear all filters and sorting

clearColumnFilterAndSort(binding: string): void {
  if (!this.flex || !this.gridFilter) {
    return;
  }

  const filterDefinition = this.getFilterDefinition();

  filterDefinition.filters = (filterDefinition.filters ?? []).filter(
    filter => filter.binding !== binding
  );

  this.gridFilter.filterDefinition = JSON.stringify(filterDefinition);

  const sorts = this.flex.collectionView.sortDescriptions;

  for (let i = sorts.length - 1; i >= 0; i--) {
    if (sorts[i].property === binding) {
      sorts.splice(i, 1);
    }
  }

  this.refreshGridState();
}
  • This clears only the selected column’s filter and sort.

 

Clear All Filters and Sorting

clearAllFiltersAndSorts(): void {
  if (!this.flex || !this.gridFilter) {
    return;
  }

  this.flex.collectionView.sortDescriptions.clear();
  this.gridFilter.clear();

  this.refreshGridState();
}
  • This resets the grid to an unfiltered and unsorted state.

 

Add the Angular Markup

<p>
  Filters ({{ filteredColumns.length }}):
  {{ filteredColumns.join(', ') || 'None' }}
</p>

<p>
  Sorts ({{ sortedColumns.length }}):
  {{ sortedColumns.join(', ') || 'None' }}
</p>

<button
  *ngFor="let column of columns"
  type="button"
  (click)="clearColumnFilterAndSort(column.binding)">
  Clear {{ column.header }}
</button>

<button type="button" (click)="clearAllFiltersAndSorts()">
  Clear All Filters and Sorting
</button>

<wj-flex-grid
  #flex
  [itemsSource]="data"
  [allowSorting]="'MultiColumn'"
  (initialized)="onGridInitialized(flex)"
  (sortedColumn)="refreshGridState()">

  <wj-flex-grid-column
    *ngFor="let column of columns"
    [binding]="column.binding"
    [header]="column.header">
  </wj-flex-grid-column>

  <wj-flex-grid-filter
    #gridFilter
    (initialized)="onFilterInitialized(gridFilter)"
    (filterApplied)="refreshGridState()">
  </wj-flex-grid-filter>
</wj-flex-grid>
  • The filterApplied event refreshes the filter count, and the sortedColumn event refreshes the sort information.

 

With this setup, the Angular application can show the number of active filters, display the column names for active filters and sorts, clear one column’s filter and sort, or clear all filters and sorting from the grid.

Happy coding!

Andrew Peterson

Technical Engagement Engineer